﻿using System;
using System.ServiceModel;
using System.Threading;

namespace CallbackContractWCF
{
    [ServiceContract(Name = "SampleDuplexHello", CallbackContract = typeof(IHelloCallbackContract), SessionMode = SessionMode.Required)]
    public interface IDuplexHello
    {
        [OperationContract(IsOneWay = true)]
        void Hello(string greeting);
    }

    public interface IHelloCallbackContract
    {
        [OperationContract(IsOneWay = true)]
        void Reply(string responseToGreeting);
    }

    public class DuplexHello:IDuplexHello
    {
        public DuplexHello()
        {
            Console.WriteLine("Service object created: " + this.GetHashCode().ToString());
        }

        ~DuplexHello()
        {
            Console.WriteLine("Service object distroyed: " + this.GetHashCode().ToString());
        }

        public void Hello(string greeting)
        {
            Console.WriteLine("Caller sent: "+greeting);
            Console.WriteLine("Session ID: "+OperationContext.Current.SessionId);
            Console.WriteLine("Waiting two seconds before returning call.");
            Thread.Sleep(2000);
            IHelloCallbackContract callerProxy = OperationContext.Current.GetCallbackChannel<IHelloCallbackContract>();
            string response = "Service object " + this.GetHashCode().ToString() + " received." + greeting;
            Console.WriteLine("Sending back: " + response);
            callerProxy.Reply(response);
        }
    }
}
